function [S] = Integral(P, G)
%This function calculate the total strength of the gray degree of each tray

%find the aveage strength of background
% a = round(Size(2)/2-Size(2)/6);
% b = round(Size(2)/2+Size(2)/6);
% c = P.line(1, 2, 2)+10;
% d = P.line(1, 1, 3)-10;
% ave = mean(mean(G(c:d, a:b)));

%1
%calculate the aveage strength of each tray & integrate
% S = zeros(P.numl, P.numr, 1);
% for i =1:P.numl
%     c = P.line(1, 1, i);
%     d = P.line(1, 2, i);
%     for j = 1:P.numr
%         a = P.row(1, 1, j);
%         b = P.row(1, 2, j);
%         s = mean(G(c:d, a:b));
%         if s(1) > s(end)
%             background = [0:(s(1)-s(end))/(b-a):(s(1)-s(end))];
%         else
%             background = [0:(s(end)-s(1))/(b-a):(s(end)-s(1))];
%         end
%         s = s-background;
%         s(find(s < 0)) = 0;
%         S(i,  j, 1) = trapz(a:b, s);
%     end
% end
% end


%3 the background is the average of each line
% S = zeros(P.numl, P.numr, 1);
% for i =1:P.numl
%     c = P.line(1, 1, i);
%     d = P.line(1, 2, i);
%     for j = 1:P.numr
%         a = P.row(1, 1, j);
%         b = P.row(1, 2, j);
%         R = 0;
%         for k = c:d
%             m = min(G(k, :));
%             f = find(G(k, :) <= 1.1*m);
%             backave = mean(G(k, f));
%             s = G(k, a:b)-backave;
%             s(find(s < 0)) = 0;
%             R = R+trapz(a:b, s);
%         end
%         S(i,  j, 1) = R/100;
%     end
% end
% end

%4    the background is the average of the tray 
S = zeros(P.numl, P.numr, 1);
for i =1:P.numl
    c = P.line(1, 1, i);
    d = P.line(1, 2, i);
    for j = 1:P.numr
        a = P.row(1, 1, j);
        b = P.row(1, 2, j);
        R = 0;
        order = 1;
        for k = c:d
            m = min(G(k, :));
            f = find(G(k, :) <= 1.1*m);
            backave(order) = mean(G(k, f));
            order = order+1;
        end
        backave(1) = mean(backave);
        for k = c:d
            s = G(k, a:b)-backave(1);
            s(find(s < 0)) = 0;
            R = R+trapz(a:b, s);
        end
        S(i,  j, 1) = R/100;
    end
end
end



%2
% S = zeros(P.numl, P.numr, 1);
% for i =1:P.numl
%     c = P.line(1, 1, i);
%     d = P.line(1, 2, i);
%     for j = 1:P.numr
%         a = P.row(1, 1, j);
%         b = P.row(1, 2, j);
%         s = mean(G(c:d, a:b));
%         m = min(G(round((c+d)/2), :));
%         f = find(G(round((c+d)/2), :) <= 1.1*m);
%         backave = mean(G(round((c+d)/2), f));
%         p = find(s > backave, 1);
%         if s(p) > s(end)
%             background = (s(p)-s(end)):-(s(p)-s(end))/(b-a-p+1):0;
%         else
%             background = 0:(s(end)-s(p))/(b-a-p+1):(s(end)-s(p));
%         end
%         s(p:end) = s(p:end)-background;
%         s(find(s < 0)) = 0;
%         S(i,  j, 1) = trapz((a+p-1):b, s(p:end));
%     end
% end
% end