function [P_storel P_storer line_store row_store] = findedge(G1, G2)
%  find the edge
%  ave = mean(mean(G(1:5, 1:Size(1)/2)));% if ave>0.03?
%  Max = max(max(G(1:5, 1:Size(1)/2)));
%  amax = Max-ave;
%  dif = amax-ave;
 
 % define (0,0)=top left corner of the image
 %find the top & bottom of the trap
 P_storel = ones(1, 2, 1);
 P_storer = ones(1, 2, 1);
 i  = 1;
 line = 0;
 bol = 0;
 Size = size(G1);
 while i <= Size(1)-1
    if bol == 1 && insureB(i, G1, Size, 1) && (i-P_storel(1, 1, line)) > 25
%             && (i-P_storel(1, 1, line)) >20
        P_storel(1, 2, line) = i;
        bol = 0;
        i = i+1;
        continue;
    elseif bol == 0 && insureT(i, G1, Size, 1)
%             && (line == 0 || (i-P_storel(1, 2, line))>20) % increase the accuracy
        line = line +1;
        P_storel(1,1,line) = i;
        bol = 1;
        i = i+1;
        continue;
    else
        i = i+1;
    end
 end
 
 line_store = line;
 
 %find the left & right edge of the trap
 G = G2';
 j = 1;
 row = 0;
 bol = 0;
 while j <= Size(2)-1
    if bol == 1 && insureB(j, G, Size, 2) && (j-P_storer(1, 1, row)) > 25
        P_storer(1, 2, row) = j;
        bol = 0;
        j = j+1;
        continue;
    elseif bol == 0 && insureT(j, G, Size, 2)
        row = row +1;
        P_storer(1,1,row) = j;
        bol = 1;
        j = j+1;
        continue;
    else
        j = j+1;
    end
 end
 
 row_store = row;
 
 
 
% adjust the edge to contain some background
 for i = 1:numel(P_storel)
     if mod(i, 2) == 1
         P_storel(i) = P_storel(i)-5;
     else
         P_storel(i) = P_storel(i)+10;
     end
 end
 for j = 1:numel(P_storer)
     if mod(j, 2) == 1
         P_storer(j) = P_storer(j)-5;
     else
         P_storer(j) = P_storer(j)+10;
     end
 end
 if P_storel(1) < 1
     P_storel(1) = 1;
 end
 if P_storel(end) < P_storel(end-1)
     P_storel(end) = Size(1);
 end
  if P_storer(1) < 1
     P_storer(1) = 1;
 end
 if P_storer(end) < P_storer(end-1)
     P_storer(end) = Size(2);
 end

%  something wrong in the bottom of the last line and row, avoid it!
i = 1;
 while i < line_store
     if P_storel(1, 1, i+1)-P_storel(1, 2, i) <= 5
         [P_storel line_store]= adjust(P_storel, i, line_store);
     end
     i = i+1;
 end
 i = 1;
  while i < row_store
     if P_storer(1, 1, i+1)-P_storer(1, 2, i) <= 5
         [P_storer row_store] = adjust(P_storer, i, row_store);
     end
     i = i+1;
  end
end